//
//  SelectorScreen.cpp
//  PokktSample
//
//  Created by Pankaj Kumar on 22/04/15.
//
//

#include "SelectorScreen.h"
#include "IwGx.h"
#include "input.h"
#include "resources.h"
#include "mainMenu.h"
#include "UIComponents.h"
#include "PokktNativeManager.h"
#include "Storage.h"

SelectorScreen::~SelectorScreen()
{
    
}

void SelectorScreen::Update(float deltaTime, float alphaMul)
{
    if(!m_IsActive)
        return;
    
    Scene:Scene::Update(deltaTime, alphaMul);
    
    //Detect screen tap
    if(m_IsInputActive && m_Manager->GetCurrent() == this && !g_pInput->m_Touched && g_pInput->m_PrevTouched)
    {
        g_pInput->Reset();
        if(autoCacheBtn->HitTest(g_pInput->m_X, g_pInput->m_Y))
        {
           MainMenu* mainMenu = (MainMenu*)g_pSceneManager->Find("mainmenuscreen");
            Storage::setAutoCaching(true);
            g_pSceneManager->SwitchTo(mainMenu);
        }
        else if(sansAutoCacheBtn->HitTest(g_pInput->m_X, g_pInput->m_Y))
        {
            MainMenu* mainMenu = (MainMenu*)g_pSceneManager->Find("mainmenuscreen");
            Storage::setAutoCaching(false);
            g_pSceneManager->SwitchTo(mainMenu);
        }
    }
}

void SelectorScreen::Render()
{
    Scene::Render();
}

void SelectorScreen::Init()
{
    Scene::Init();
    
    // Create UI
    CSprite* background = UIComponents::getSprite((float)IwGxGetScreenWidth() / 2, (float)IwGxGetScreenHeight() / 2, g_pResources->getScreenBG(), 0.5f, 0.5f);
    // Fit background to screen size
    background->m_ScaleX = (float)IwGxGetScreenWidth() / background->GetImage()->GetWidth();
    background->m_ScaleY = (float)IwGxGetScreenHeight() / background->GetImage()->GetHeight();
    AddChild(background);
    
    CSprite* logo = UIComponents::getSprite((float)IwGxGetScreenWidth() / 2, (float)IwGxGetScreenHeight() * 0.32f, g_pResources->getLogo(), 0.5f, 0.5f);
    AddChild(logo);
    
    float y_pos = (float)IwGxGetScreenHeight() * 0.56f;
    autoCacheBtn = UIComponents::getSprite(IwGxGetScreenWidth() / 2.0f, y_pos, g_pResources->getBlueButton(), 0.5f, 0.5f);
    AddChild(autoCacheBtn);
    
    y_pos = (float)IwGxGetScreenHeight() * 0.575f;
    CLabel* autoCacheLbl = UIComponents::getLabel((float)IwGxGetScreenWidth() / 2.0f, y_pos, (float)IwGxGetScreenWidth(), 30, 0.5f, 0.5f, IW_2D_FONT_ALIGN_CENTRE, IW_2D_FONT_ALIGN_TOP, CColor(0xff, 0xff, 0x30, 0xff), "Auto Cache Video");
    AddChild(autoCacheLbl);
    
    y_pos = (float)IwGxGetScreenHeight() * 0.64f;
    sansAutoCacheBtn = UIComponents::getSprite((float)IwGxGetScreenWidth() / 2.0f, y_pos, g_pResources->getBlueButton(), 0.5f, 0.5f);
    AddChild(sansAutoCacheBtn);
    
    y_pos = (float)IwGxGetScreenHeight() * 0.655f;
    CLabel* sansAutoCacheLbl = UIComponents::getLabel((float)IwGxGetScreenWidth() / 2.0f, y_pos, (float)IwGxGetScreenWidth(), 30, 0.5f, 0.5f, IW_2D_FONT_ALIGN_CENTRE, IW_2D_FONT_ALIGN_TOP, CColor(0xff, 0xff, 0x30, 0xff), "Sans Auto Cache Video");
    AddChild(sansAutoCacheLbl);
}
